USE DemoProgramming
go

SET STATISTICS IO ON
SET STATISTICS TIME ON
go

--Show them the data
SELECT
    ParseExampleID
   ,CDString
FROM
    ParseExample

-----------------------------------------
--	Cursor--
-----------------------------------------
DECLARE @CDString AS varchar(100)
DECLARE @Seperator AS char(1) = ','

DECLARE parse_cursor CURSOR FOR
	SELECT
		CDString
	FROM
		ParseExample
OPEN parse_cursor
FETCH NEXT FROM parse_cursor
INTO @CDString

WHILE @@FETCH_STATUS = 0
BEGIN

	;WITH Pieces(ID, StartString, StopString)
    AS 
    (
		SELECT
			 1
			,1
			,CHARINDEX(@Seperator, @CDString)
		UNION ALL
		SELECT
			ID + 1
			,StopString + 1
			,CHARINDEX(@Seperator, @CDString, StopString + 1)
		FROM
			Pieces
		WHERE
			StopString > 0
	)
	,cte_Seperated
	AS
	(
		SELECT
			ID
		   ,SUBSTRING(@CDString, StartString, CASE WHEN StopString > 0 THEN StopString - StartString
														ELSE LEN(@CDString)
												   END) AS SeparatedValue
		FROM
			Pieces  
	)
	SELECT
		SUM(CONVERT(int,SeparatedValue)) asSumofValues
	FROM
		cte_Seperated

	FETCH NEXT FROM parse_cursor INTO @CDString
END

CLOSE parse_cursor
DEALLOCATE parse_cursor

GO

---------------------------------------------
-- WHILE
---------------------------------------------
DECLARE @CDString AS varchar(100)
DECLARE @Seperator AS char(1) = ','
DECLARE @i AS integer = 1

WHILE @i<=10
BEGIN

	SELECT 
		@CDString = CDString
	FROM
		dbo.ParseExample AS pe
	WHERE
		ParseExampleID = @i
	
	;WITH Pieces(ID, StartString, StopString)
    AS 
    (
		SELECT
			 1
			,1
			,CHARINDEX(@Seperator, @CDString)
		UNION ALL
		SELECT
			ID + 1
			,StopString + 1
			,CHARINDEX(@Seperator, @CDString, StopString + 1)
		FROM
			Pieces
		WHERE
			StopString > 0
	)
    ,cte_Seperated
	AS
	(
		SELECT
			ID
		   ,SUBSTRING(@CDString, StartString, CASE WHEN StopString > 0 THEN StopString - StartString
														ELSE LEN(@CDString)
												   END) AS SeparatedValue
		FROM
			Pieces  
	)
	SELECT
		SUM(CONVERT(int,SeparatedValue)) asSumofValues
	FROM
		cte_Seperated

	SET @i = @i + 1
END
GO
-------------------------------------
--  Scalar UDF
-------------------------------------

SELECT
	dbo.fn_SplitSumScalar(',', CDString) AS SumSplit
FROM 
	dbo.ParseExample


-------------------------------------
--  In-line Table Function
-------------------------------------

SELECT
	ss.SumSplit
FROM 
	dbo.ParseExample AS pe
	CROSS APPLY dbo.fn_SplitSum(',', pe.CDString)  AS ss